
RealMatrix trafoMatrix(float a1, float d1, float b1, float p1 ) {                           // Eine Funktion zur Berechnung der Transformationsmatrix
                                                                                            // zwischen zwei Gelenken wird erstellt.

  double [][]  matrixData =  {{cos(p1), -sin(p1)*cos(b1),  sin(p1)*sin(b1), a1*cos(p1)}, 
                              {sin(p1),  cos(p1)*cos(b1), -cos(p1)*sin(b1), a1*sin(p1)}, 
                              {      0,          sin(b1),         cos(b1),          d1}, 
                              {      0,                0,               0,           1}};

  RealMatrix m = MatrixUtils.createRealMatrix(matrixData);
  return m;
}

RealMatrix gelenkArm( float winkel1, float winkel2, float winkel3) {                        // Funktion zur Berechnung der Transformationsmatrix
                                                                                            // des gesamten Arms im Bezug zum Basisgelenk.

  RealMatrix ArmTeil1 = trafoMatrix(0   ,  4.5    , HALF_PI  , winkel1 ); 
  RealMatrix ArmTeil2 = trafoMatrix(26  ,   0     ,    0     , winkel2);
  RealMatrix ArmTeil3 = trafoMatrix(22.5,  4.5    ,    0     , winkel3);

  RealMatrix gesamtArmTeilMatrix = ArmTeil1.multiply(ArmTeil2.multiply(ArmTeil3));


  return gesamtArmTeilMatrix;
}

RealVector endEffectorPosCalc(float winkel1, float winkel2, float winkel3) {
  
  RealVector oneVector = MatrixUtils.createRealVector(new double[] { 0, 0, 0, 1});          // Führt vom Koordinatenursprung des Endeffektor-
                                                                                            // Koordinatensystems zu dem interessanten Punkt.
  RealVector endEffectorPos = gelenkArm (winkel1, winkel2, winkel3).operate(oneVector);
  println("endEffectorPos"+endEffectorPos);
  return endEffectorPos;
}