
public static final double MINDIFF = 0.01;
public RealMatrix jacobiBerechnung (float w1, float w2, float w3) {  // Für jeden Winkel 2 funktionsaufrufe bei dem jeder winkel positive und negativ richtung insgesamt 6 aufrufe (1 spalte jacobi 1 winkel, skoordinatenachse, 2 funktionsaufrufe eine spalte


  RealMatrix jacobi= MatrixUtils.createRealMatrix(3, 3)  ;
  float [] w = {0.0, 0.0, 0.0};
  w[0] = w1;
  w[1] = w2;
  w[2] = w3;

  float [] wA = w, wB = w;

  float diffStep=0.01; //Abstand zwischen zwei Funktions


  for (int i=0; i < w.length; i++) {
    // bereite zwei parameter punkte vor und hinter dem gefragten vor, an denen wir die Fuktion aufrufen:
    wA[i] -= diffStep;
    RealVector eEPosA = endEffectorPosCalc(wA[0], wA[1], wA[2]);

    wB[i] += diffStep;
    RealVector eEPosB = endEffectorPosCalc(wB[0], wB[1], wB[2]);

    for (int j=0; j < 3; j++) {       
      jacobi.setEntry(j, i, (eEPosB.getEntry(j) - eEPosA.getEntry(j))/(2*diffStep)) ;  //Steigungsdreieck wird berechnet
    }
  }

return jacobi;
}

RealVector gibWinkel(RealVector endEPosNew, RealVector winkelVector ) {


  RealVector endEPosAkt = endEffectorPosCalc((float)winkelVector.getEntry(0), (float)winkelVector.getEntry(1), (float)winkelVector.getEntry(2)).getSubVector(0, 3);  
  double abstand = endEPosNew.getDistance(endEPosAkt); 

  Math.abs(abstand);
  RealMatrix jacobi= jacobiBerechnung((float)winkelVector.getEntry(0), (float)winkelVector.getEntry(1), (float)winkelVector.getEntry(2));

  DecompositionSolver solver = new SingularValueDecomposition(jacobi).getSolver();
  RealVector solution = solver.solve(endEPosNew.subtract(endEPosAkt));

  print(" WinkelSchritt ");           
  println(solution);

  RealVector neuerWinkel = winkelVector.add(solution.mapMultiply(0.01)); //Schrittweite wurde verkleinert
  println("alter WinkelVector" + winkelVector);
  
  println("neuer WinkelVector" + neuerWinkel);
 
return neuerWinkel;
}