
Capture video;
OpenCV opencv;

void setupMunderkennung() {
  video = new Capture(this, 640/2, 480/2, "Logitech HD Webcam C270");
  opencv = new OpenCV(this, 640/2, 480/2);
  opencv.loadCascade(OpenCV.CASCADE_MOUTH);  

  video.start();
}

  float x;
  float y;
  float z;
  
RealVector drawMunderkennung() {
  scale(2);
  opencv.loadImage(video);

  image(video, 0, 0 );

  noFill();
  stroke(0, 255, 0);
  strokeWeight(3);
  
  
  //default values for detect-function: (double scaleFactor=1.1, int minNeighbors=3, int flags=0, Size minSize=Size(), Size maxSize=Size() )
  Rectangle[] mouth = opencv.detect(1.1, 200, 0, 0, 200);
  //println(mouth.length); // ggf. Ausgabe der Größe des Kästchens um den Mund

  for (int i = 0; i < mouth.length; i++) {
    //println("linksx=" + mouth[i].x + ", obeny=" + mouth[i].y);
    
    rect(mouth[i].x, mouth[i].y, mouth[i].width, mouth[i].height);  // zeichne Rechteck um denn Mund
    //println("b=" + mouth[i].width + ", h=" + mouth[i].height);    // ggf. Ausgabe von b=Breite & h=Höhe des Kästchens
    
    z = (400*5.7)/mouth[i].width;                                   // z = Entfernung Kamera-Mund [cm]
    
    float xCam = (mouth[i].x+((mouth[i].width)/2)-160);             // xCam = x-Achsenabschnitt im Kamerabild [px]
    float yCam = (mouth[i].y+((mouth[i].height)/2)-120);            // yCam = y-achsenabschnitt im Kamerabild [px]
    //println("x=" + xCam + " y=" + yCam);                          // ggf. Ausgabe von x- & y-Achsenabschnitt im Kamerabild

    x = z*(xCam/400);                                               // x = x-Abstand zur Bildmitte [cm]
    y = z*(yCam/400);                                               // y = y-Abstand zur Bildmitte [cm]
    //println("Entfernung[cm]: d=" + z);
    
    println("x=" + x + " | y=" + y + " | z=" + z);
  }
  
  RealVector camKoordinaten = MatrixUtils.createRealVector(new double[] { x, y, z});      // erstelle Vektor 'camKoordinaten' mit Kamerakoordinaten
  println("camKoordinaten " + camKoordinaten);
  return camKoordinaten;                                     // übergebe den Vektor 
}

void captureEvent(Capture c) {
  c.read();
}