
//import MUNDERKENNUNG
import gab.opencv.*;
import processing.video.*;
import java.awt.*;

//import WINKELBERECHNUNG
// Programm zur Berechnung der Winkel zur Ansteuerung des Mundes  

/*Unser Roboter besteht aus 3 Armteilen, 3 Gelenken und dementsprechend 3 Winkeln. Die Endeffektorposition des Roboters ist abhängig von den einzelnen Winkel der Gelenke. 
 Da sich die Winkel nicht eindeutig bestimmen lassen benutzen wir 
 ein Verfahren dass durch Annäherung die Winkel bestimmt, nach diesem Schema : f(w)≈ f(w)+ J(w)x = b (Newton-Verfahren).Diese Gleichung wird in die Form AX=B gebracht, 
 um zur Berechnung der Winkel Apache Library Funktionen (Decomposer) aufrufen zu können.*/
import org.apache.commons.math3.analysis.MultivariateMatrixFunction;
import org.apache.commons.math3.linear.*;
import org.apache.commons.math3.analysis.MultivariateVectorFunction;
import org.apache.commons.math3.linear.MatrixUtils;
import org.apache.commons.math3.linear.SingularValueDecomposition;

//import DATENÜBERTRAGUNG
import processing.serial.*;   //verwende die 'Serial' Library

//WINKELBERECHNUNG
//winkelVector enthält die Winkelangaben des Roboters.
RealVector winkelVector = MatrixUtils.createRealVector(new double [] {0, 0, 0}); //Aktuelle Winkel für die Position des Arms

//mundVonCamera enthält die Position des Mundes aus der Cameraperspektive.
RealVector zielPunkt = endEffectorPosCalc(new float [] {0, 0, 0}).getSubVector(0, 3);

//DATENÜBERTRAGUNG
Serial myPort;   // Deklariere ein Object vom Typ 'Serial', mit dem Namen 'myPort'

void setup() { 
  size(800, 600);                      //starte Bildschirmausgabe


//MUNDERKENNUNG
  setupMunderkennung();                //rufe Funktion 'setupMunderkennung' auf

  
//DATENÜBERTRAGUNG
  setupDatenuebertragung();
}


void draw () {

//MUNDERKENNUNG
  RealVector zielPunkt = drawMunderkennung();                 //rufe Funktion 'drawMunderkennung' auf


//WINKELBERECHNUNG
  println("ZielPunkt"+zielPunkt);
  // gibWinkelwird von außen aufgerufen um die Winkel zu berechnet. Diese werden in winkelVector gespeichert um mit diesen neuen Werten weiterzurechnen(Schleife).
  winkelVector = gibWinkel(zielPunkt, winkelVector); 


  //Schleifenendbedingung?
  
//DATENUEBERTRAGUNG
  drawDatenuebertragung();
}